﻿// ----- Global Button Script
// ----- Code by tedGo, based on a sample by T.P. Wang

var ButtonStates = {normal: 0, hover: 1, down: 2, hide: 3};
var Buttons = {};
var btn_down = false;
var cur_btn = null;
var btn_tooltip;

function buttonsDraw(gr) {
	for (var i in Buttons) Buttons[i].draw(gr);
}

function buttonsTraceMouse(x, y) {
	var btn = null;
	for (var i in Buttons) {
		if (Buttons[i].traceMouse(x, y) && !btn)
			btn = Buttons[i];
	}
	return btn;
}

function buttonsMouseMove(x, y) {
	var btn = buttonsTraceMouse(x, y);

	if (btn != cur_btn) {
		cur_btn && cur_btn.onMouseOut();
		btn && btn.onMouseIn();
	}

	cur_btn = btn;
}

function buttonsMouseLbtnDown(x, y) {
	btn_down = true;
	(btn_down = cur_btn) && cur_btn.changeState(ButtonStates.down);
}

function buttonsMouseLbtnUp(x, y) {
	if (cur_btn) {
		cur_btn.changeState(ButtonStates.hover);
		btn_down == cur_btn && cur_btn.onClick(x, y);
	}

	btn_down = false;
}

function buttonsMouseLeave() {
	cur_btn && cur_btn.changeState(ButtonStates.normal);
}