﻿// ----- Panel: Control Left
// ----- code by tedGo

var presetCount = 3;
var b_btns = [];
btn_panel = 1;

var a_name = ["", "", "CONSOLE", "", "", "TIME"];
var a_func = [function(){fb.Exit()}, getMainMenu, function(){fb.ShowConsole()}, function(){fb.RunMainMenuCommand("Show Status pane")}, function(){fb.RunMainMenuCommand("Show Status bar")}, function(){window.SetProperty("Remain Time", t_r ? false : true); TimeOpt()}];

var b_name = ["Button 01", "Button 02", "Button 03", "Button 04", "Button 05", "Button 06", "Button 07", "Button 08"];
for (var j_ = 0; j_ < 8; j_++) b_btns.push(getButtonProperties(b_name[j_]));

// ----- CREATE BUTTONS -----
buttonsOptions();
buttonsColours();

function buttonsRefresh() {
	var qx = [0, rbx, 0, bxf * 3, bxf * 5, rbx];
	for (var i = 0; i < 6; i++) Buttons["a_" + i] = new TextButton(a_name[i], a_func[i], qx[i], i > 1 ? by1 : 0, bbw, bbh, i > 1 ? btn1Siz : btn2Siz, i > 1 ? btn1Opt : btn2Opt, btnsCol);
	for (var j = 0; j < 8; j++) if (b_btns[j].Exists) Buttons["b_" + j] = new TextButton(b_btns[j].Text.toUpperCase(), AddBtnCmd, bxf * (j < 5 ? (j * 2 + 3) : (j * 2 - 3)), j < 5 ? 0 : by1, bbw, bbh, btn1Siz, btn1Opt, btnsCol, "", b_btns[j]);
}

// ----- CREATE TIMESWITCH OPTION -----
function TimeOpt() {
	t_r = window.GetProperty("Remain Time", false);
	window.NotifyOthers("remTime", t_r);
}

TimeOpt();

// ----- DRAW -----
function on_paint(gr) {
	!window.IsTransparent && gr.FillSolidRect(0, 0, ww, wh, p_backcol);

	gr.SetInterpolationMode(7);
	gr.SetSmoothingMode(4);

	g_signs && gr.DrawImage(g_signs, 0, 0, bbw, bbh, 1206, 396, 150, 72);
	g_signs && gr.DrawImage(g_signs, ww - ww / 8 - 1, 0, bbw, bbh, 1674, 396, 150, 72);

	gr.GdiDrawText("PANE --- STATUS --- BAR", gdi.Font(btn1Opt.font_name, btn1Siz.font_size), btnsCol.text_normal, bxf * 3, by1, bbw * 2, Math.ceil(bbh / 3 * 2), 1);
	buttonsDraw(gr);
}

// ----- MOUSE ACTIONS -----
function on_mouse_move(x, y) {
	buttonsMouseMove(x, y);
}

function on_mouse_lbtn_down(x, y) {
	buttonsMouseLbtnDown(x, y);
}

function on_mouse_lbtn_up(x, y) {
	buttonsMouseLbtnUp(x, y);
}

function on_mouse_rbtn_up(x, y) {
	var a = window.CreatePopupMenu();
	var b = window.CreatePopupMenu();
	var c = window.CreatePopupMenu();
	var d = window.CreatePopupMenu();
	var idx;

	for (var i = 0; i < 8; i++) b.AppendMenuItem(b_btns[i].Exists ? 8 : 0, i + 101, b_btns[i].Text ? b_btns[i].Text : b_name[i]);
	b.AppendMenuSeparator();
	b.AppendMenuItem(0, 109, "Edit buttons");

	for (var j = 1; j >= 1 && j <= presetCount; j++) c.AppendMenuItem(0, j + 200, "Preset " + j);
	c.CheckMenuRadioItem(201, 200 + presetCount, appPreset + 200);

	var tmp_arr = ["Flat", "Soft", "Medium", "Strong"];
	for (var k = 0; k < 4; k++) d.AppendMenuItem(0, k + 301, tmp_arr[k]);
	d.CheckMenuRadioItem(301, 304, depthPreset + 301);

	b.AppendTo(a, 0 | 16, "Optional buttons");
	a.AppendMenuSeparator();
	c.AppendTo(a, 0 | 16, "Button style");
	d.AppendTo(a, 0 | 16, "Button depth");

	idx = a.TrackPopupMenu(x, y);

	if (idx >= 101 && idx <= 108) {
		window.SetProperty(b_name[idx - 101], b_btns[idx - 101].Exists ? false : true);
		if (b_btns[idx - 101].Exists) window.Reload();
		else {
			getButtonProperties(b_name[idx - 101]);
			var vb_cmmnd = vb.InputBox("Enter your desired command here.", "Button command", b_btns[idx - 101].CmdString);
			var vb_name = vb.InputBox("Enter the name for the button here.", "Button name", b_btns[idx - 101].BtnName.toUpperCase());
			window.SetProperty(b_name[idx - 101] + " command string", vb_cmmnd);
			window.SetProperty(b_name[idx - 101] + " name (up to 10 letters)", vb_name);
			window.Reload();
		}
	}

	if (idx === 109) window.ShowProperties();

	if (idx >= 201 && idx <= 200 + presetCount) {
		window.SetProperty("Buttons appearance preset", idx - 200);
		appPreset = window.GetProperty("Buttons appearance preset");
		window.NotifyOthers("ButtonPreset", appPreset);
		buttonsOptions();
		buttonsSizes();
		buttonsRefresh();
		window.Repaint();
	}

	if (idx >= 301 && idx <= 304) {
		window.SetProperty("Buttons depth preset", idx - 301);
		depthPreset = window.GetProperty("Buttons depth preset");
		window.NotifyOthers("DepthPreset", depthPreset);
		buttonsOptions();
		buttonsRefresh();
		window.Repaint();
	}

	a.Dispose();
	b.Dispose();
	c.Dispose();
	d.Dispose();

	return true;
}

function on_mouse_leave() {
	buttonsMouseLeave();
}

// ----- EVENTS -----
function on_size() {
	ww = window.Width;
	wh = window.Height;

	buttonsSizes();
	buttonsRefresh();
}